//////////////////////////////////////////////////////////////////////
// Nes Mapper 2.cpp - Implementation of mapper #2 (UNROM)
//////////////////////////////////////////////////////////////////////

#include "NesMapper2.h"



NesMapper2::NesMapper2(NesCartridge *linkCartridge, NesCPU *linkCPU, NesPPU *linkPPU)
{
	mCartridge = linkCartridge;
	mCpu = linkCPU;
	mPpu = linkPPU;
	
	bytPRGCount = mCartridge->header.PRGROM_count;
	bytCHRCount = mCartridge->header.CHRROM_count;
	
	initMaps();
}


void NesMapper2::initMemory()
{	
	if (bytPRGCount > 0)
	{
		swapPRGBank16(0x8000, 0);			  // First 16k bank to $8000
		swapPRGBank16(0xC000, bytPRGCount-1); // Last 16k bank ot $C000
	}
}


void NesMapper2::write(unsigned __int16 addr, unsigned char data)
{	
	// Copy a 16K bank of PRG-ROM to $8000
	// Possible bug: might have to mod (prgcount + 1) instead
	swapPRGBank16(0x8000, data % bytPRGCount);	
}